/*
Aug. 13/97. This is a card game I wrote along time ago. I don't think
Clipper is really intended for game programming, but I thought I would see
what I could do. It's not documented and as I recall there are a few bugs.
Anyway, it's public domain. Do as you like with it.
If you fix it up, it would be nice of you to send me a copy.

Regards, TestedOK@aol.com
*/

#command  CLS           => setcolor("bg+/"+cbackgroundcolor); __Clear();banner()
#command  CLRSCR           =>  __Clear()

#include "inkey.ch"

static adeck
static ncardval := 1
static ccardname := 2
static spade := chr(6)
static heart := chr(3)
static club := chr(5)
static diamond := chr(4)
static cstatuscolor
static cbackgroundcolor := "r+"
static cardmatcolor 
static cmessagecolor := "g/n"
static cinputcolor := "gr+/n,gr+/n"
static cdealcolor := "bg+/n"
static ndecksize := 52
static ndelay := 2
static nhousemax := 500
static ncardsleft := 0
static ndeckpos := 1

function playbetween()
  local nplayers := 2
  local ninitialbet := 1.00
  local getlist := {}
  local aplayers := {}
  local awon := {}
  local nrow := 5
  local n
  local npotval := 0
  local nlow,nmiddle,nhigh
  local ncardrow := 8
  local cplayagain := "Y"
  local nkey
  local cpict
  local nbet

  cmessagecolor := "bg+*/"+cbackgroundcolor
  cinputcolor := "gr+/"+cbackgroundcolor+",gr+/" +cbackgroundcolor
  cdealcolor := "bg+/"+cbackgroundcolor
  cstatuscolor := "bg+/"+cbackgroundcolor
  cardmatcolor := "w/"+cbackgroundcolor

  ncardsleft := 0
  setmode(25,40)
  setkey(K_F1,{||helpbetween()})
  //setcursor(2)
  set confirm on
  setcolor(cinputcolor)
  cls
  
  setcolor(cinputcolor)
  @10,0 say "How many players (1-9)? " get nplayers picture "9";
            valid nplayers > 0 .and. nplayers < 21
  read
  cls
  setcolor(cinputcolor)
  for n := 1 to nplayers
    aadd(aplayers,space(10))
  next
  for n := 1 to len(aplayers)
    @nrow,5 say "Player #"+alltrim(str(n))+ "'s name? " get aplayers[n]
    nrow++
  next
  read
  for n := 1 to len(aplayers)
    if empty(aplayers[n])
      aplayers[n] := "Player # "+alltrim(str(n))
    endif
  next
  nrow++
  @nrow,0 say "How much is the ante? " get ninitialbet picture "999.99"
  read
  npotval := ninitialbet * nplayers
  cls
  shuffmessage()
  cardmat()
  newdeck()
  shuffle()
  ncardsleft := ndecksize
  ndeckpos := 1
  awon := array(len(aplayers))
  afill(awon,ninitialbet-ninitialbet*2)
  // main loop
  setkey(-9,{||showwinnings(aplayers,awon)})
  do while .t.
     for n := 1 to len(aplayers) // deal cards to each player
       if npotval < .01
         exit
       endif
       cls
       cardmat()
       /*
       nlow := adeck[ndeckpos,1]
       dealcard(ncardrow,6,adeck[ndeckpos,2]) //4
       nhigh := adeck[ndeckpos,1]
       dealcard(ncardrow,27,adeck[ndeckpos,2]) //25
       */
       
       nlow := adeck[ndeckpos,1]
       nhigh := adeck[ndeckpos+1,1]
       if nlow <= nhigh
         dealcard(ncardrow,6,adeck[ndeckpos,2]) 
         dealcard(ncardrow,27,adeck[ndeckpos+1,2]) 
         else
         dealcard(ncardrow,6,adeck[ndeckpos+1,2]) 
         dealcard(ncardrow,27,adeck[ndeckpos,2]) 
       endif
       ncardsleft --
       ndeckpos ++
       ncardsleft --
       ndeckpos ++

       potvaluemess(npotval)
       setcolor(cinputcolor)
       nbet := 0
       clear typeahead
       nkey := inkey()
       cpict := replicate("9",len(alltrim(str(npotval)))-3) + ".99"
       @maxrow(),0 say alltrim(aplayers[n])+", what's your bet?" get nbet; 
         picture cpict valid nbet <= npotval 
         read
       if lastkey() = 27
         setmode(25,80)
         clrscr
         return nil
       endif
       if nbet = 0
         loop
       endif
       nmiddle := adeck[ndeckpos,1]
       dealcard(ncardrow,17,adeck[ndeckpos,2]) //15
       ncardsleft --
       ndeckpos ++
       clrmessage()
       if nmiddle > min(nlow,nhigh) .and. nmiddle < max(nlow,nhigh) // winner
         message(alltrim(aplayers[n])+", WINS "+alltrim(str(nbet)),"g/"+cbackgroundcolor)
         npotval -= nbet
         awon[n] += nbet
         else
         message(alltrim(aplayers[n])+", LOOSES "+alltrim(str(nbet)),"r/"+cbackgroundcolor)
         npotval += nbet
         awon[n] -= nbet
       endif  
       anykeymessage()
       inkey(0)
       if npotval < .01
         exit
       endif
     next
     if alltrim(str(npotval)) <> "0.00"  // still money in pot
       loop
     endif
     cls
     cardmat()
     showwinnings(aplayers,awon)
     afill(awon,ninitialbet-ninitialbet*2)
     setpos(maxrow()-1,0)
     center("Pot is broke!")
     setcolor(cinputcolor)
     set confirm off
     @maxrow(),10 say "Play again (Y/N)?" get cplayagain picture "@!"
     read
     set confirm on
     if cplayagain = "Y"
       cls
       shuffmessage()
       newdeck()
       shuffle()
       ncardsleft := ndecksize
       ndeckpos := 1
       npotval := ninitialbet * nplayers
       loop
     endif
     exit
  enddo
  // end of main loop
  setmode(25,80)
  clrscr
  return nil

static function random(nseed)
 local aray := {77111.35,787919.17,89717.99,77555.11,52212.55,36636.09,;
                63838.18,35283.67,49784.67,66325.33,;
                61288.87,93117.25,11259.56,83197.45,53513.89,79918.56}
 local nretval := 0
 local nlen
 local ctemp := ""
 local npos := 0
 static nstep := 1
 if nseed = nil .or. nseed = 0
   return nseed := int(seconds())
 endif
 while .t.
   nstep ++
   if nstep > len(aray)
     nstep := 1
   endif
   nretval := nseed*aray[nstep]/seconds()*int(seconds())
   ctemp := str(nretval)
   npos := at(".",ctemp)
   nlen := len(alltrim(str(nseed)))
   if npos > 0
     ctemp := substr(ctemp,1,npos-1)+substr(ctemp,npos+1,len(ctemp))
   endif
   ctemp := right(ctemp,nlen)
   nretval := val(ctemp)
   if nretval <= nseed
     exit
   endif
 enddo
return nretval




static FUNCTION center(cstr) //center a string 
  local n
  n:=len(cstr)/2
  @row(),maxcol()/2-n say cstr
  return ""


  
static FUNCTION BoxShadow( nTop, nLeft, nBottom, nRight )
   LOCAL nShadTop, nShadLeft, nShadBottom, nShadRight
   
   nShadTop   := nShadBottom := MIN(nBottom + 1, MAXROW())
   nShadLeft  := nLeft + 1
   nShadRight := MIN(nRight + 1, MAXCOL())

   RESTSCREEN( nShadTop, nShadLeft, nShadBottom, nShadRight,;
       TRANSFORM( SAVESCREEN(nShadTop, nShadLeft, nShadBottom, nShadRight),;
       REPLICATE("X", nShadRight - nShadLeft + 1 ) ) )

   nShadTop    := nTop + 1
   nShadLeft   := nShadRight := MIN(nRight + 1, MAXCOL())
   nShadBottom := nBottom

   RESTSCREEN( nShadTop, nShadLeft, nShadBottom, nShadRight,;
       TRANSFORM( SAVESCREEN(nShadTop,  nShadLeft , nShadBottom,  nShadRight),;
       REPLICATE("X", nShadBottom - nShadTop + 1 ) ) )
   
   RETURN NIL

static function shuffmessage()  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  setpos(maxrow(),0)
  center("Please wait while I shuffle the deck...")
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function message(cmess,ccolor)  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  if ccolor <> nil
     setcolor(ccolor)
  endif
  setpos(maxrow(),0)
  center(cmess)
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function clrmessage()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow(),0 clear to maxrow(),maxcol()
  setcolor(coldcolor)
  return nil


static function newdeck()
  local n,nn,nctr := 1
  static atemp := {}

  if len(atemp) > 0 // build new deck only once
    adeck := aclone(atemp)
    return nil
  endif
  
  adeck := array(ndecksize,2)  // ndecksize is 52 for single deck
  for nn := 3 to 6  // add ace's
      adeck[nctr,1]:=14
      adeck[nctr,2] := "A" + chr(nn)
      nctr++
  next
  for n := 2 to 10 // regular cards
    for nn := 3 to 6  // add the suits
      adeck[nctr,1]:=n
      adeck[nctr,2] := alltrim(str(n)) + chr(nn)
      nctr++
    next
  next
  for nn := 3 to 6  // add jack's
    adeck[nctr,1]:=11
    adeck[nctr,2] := "J" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add queen's
    adeck[nctr,1]:=12
    adeck[nctr,2] := "Q" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add king's
    adeck[nctr,1]:=13
    adeck[nctr,2] := "K" + chr(nn)
    nctr++
  next
  atemp := aclone(adeck)
return nil


static function shuffle()
  local n,ncard
  local atemp := array(52,2)
  
  for n := 1 to 52
    do while .t.
      ncard := random(52)
      if ncard = 0
        loop
      endif
      if adeck[ncard,1] <> 99
        atemp[n,1] := adeck[ncard,1]
        atemp[n,2] := adeck[ncard,2]
        adeck[ncard,1] := 99
        exit
      endif
    enddo
  next
  adeck := aclone(atemp)
return nil



static function  potvaluemess(npotval)
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 clear to maxrow()-2,maxcol()
  setpos(maxrow()-2,0)
  center("There is "+alltrim(str(npotval))+" in the pot.")
  setcolor(coldcolor)
return nil

static function anykeymessage()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 clear to maxrow()-2,maxcol()
  setpos(maxrow()-2,0)
  center("Strike any key...")
  setcolor(coldcolor)
return nil

static function banner()
 local coldcolor := setcolor("r/w")
 @0,0 clear to 0,maxcol()
 center("BETWEEN")
 @0,0 say "F1=help"
 pright("F10=Status")
 setcolor(coldcolor) 
return nil

static function pright(cstr) // right justify a string
  local nlen := len(cstr)
  @row(),maxcol()-nlen+1 say cstr
  return nil

function showwinnings(aplayers,awon)
 local coldcolor := setcolor("gr+/r")
 local coldscr := savescreen(0,0,maxrow(),maxcol())
 local n

 clrscr
 banner()
 setpos(5,0)
 for n := 1 to len(aplayers)
   ? "       ",aplayers[n], awon[n]
 next
 ?
 ?
 center( "Strike any key..." )
 inkey(0)
 setcolor(coldcolor)
 restscreen(0,0,maxrow(),maxcol(),coldscr)
 return nil



static function cardmat()
local coldcolor := setcolor(cardmatcolor)
local n
local ntop := 4,nleft:=3,nbott := 18,nright
nright := maxcol()-6
for n := ntop to nbott
  @n,nleft say replicate( chr(177),nright )
next
@ntop,nleft to nbott,nright+3 double
boxshadow(ntop,nleft,nbott,nright+3)
setcolor(coldcolor)
return nil


static function dealcard(nrow,ncol,ccardname )
  local n, noldrow := nrow
  local coldcolor := setcolor("b/w")
  static ndealt := 0
  if ncardsleft < 4
     shuffmessage()
     newdeck()
     shuffle()
     ncardsleft := ndecksize
     ndeckpos := 1
     clrmessage()
  endif
  
  setpos(nrow,ncol)
  
  @nrow,ncol to nrow + 5 , ncol + 6
  boxshadow(nrow,ncol,nrow + 5,ncol + 6)
  for n:=1 to 4
    @nrow+1,ncol+1 say replicate(" ",5)
    nrow++
  next
  nrow := noldrow
  if right(alltrim(ccardname),1) = chr(6) .or.; // it's a club or spade
        right(alltrim(ccardname),1) = chr(5)
    setcolor("n/w")
    else
    setcolor("r/w")
  endif
  @nrow+1,ncol+1 say alltrim(ccardname)
  @nrow+4,ncol+6-len(alltrim(ccardname)) say alltrim(ccardname)
  setcolor(coldcolor)
  //ncardsleft --
  //ndeckpos ++
  ndealt ++
  return nil

static function olddealcard(nrow,ncol,ccardname )
  local n, noldrow := nrow
  local nmaxrow := nrow+6,nmaxcol:=ncol+7
  local coldcolor := setcolor("b/w")
  static ndealt := 0
  if ncardsleft < 3
     shuffmessage()
     newdeck()
     shuffle()
     ncardsleft := ndecksize
     ndeckpos := 1
     clrmessage()
  endif
  
  setpos(nrow,ncol)
  
  @nrow,ncol to nmaxrow  , nmaxcol 
  boxshadow(nrow,ncol,nmaxrow ,nmaxcol )
  for n:= nrow+1 to nmaxrow - 1
    @nrow+1,ncol+1 say replicate(" ",nmaxcol-ncol-1)
    nrow++
  next
  nrow := noldrow
  if right(alltrim(ccardname),1) = chr(6) .or.; // it's a club or spade
        right(alltrim(ccardname),1) = chr(5)
    setcolor("n/w")
    else
    setcolor("r/w")
  endif
  @nrow+1,ncol+1 say alltrim(ccardname)
  @nmaxrow-1,nmaxcol-len(alltrim(ccardname)) say alltrim(ccardname)
  setcolor(coldcolor)
  //ncardsleft --
  //ndeckpos ++
  ndealt ++
  return nil


function helpbetween()
  local coldscr := savescreen(0,0,maxrow(),maxcol())
  local coldcolor := setcolor("gr+/r")
  setmode(25,80)
  clrscr
  banner()
  setpos(2,0)
  TEXT
    In the game of BETWEEN, a standard deck of cards is used.  You will
    be prompted to enter the number of players and their names.  You will  
    be then asked to enter the amount of each players ANTE.  Each player
    will be dealt 2 cards, face up.  The object of the game is to have the 
    next card dealt be in BETWEEN the 2 previously dealt cards.  Prior to
    receiving the 3rd card, the player is prompted to bet an amount less 
    than or equal to the value in the pot. To "pass" enter 0 as the bet. 
    If the player bets and the card received is BETWEEN the 2 cards 
    previously dealt, the player wins the amount equal to their bet. If 
    the card is not BETWEEN, the player looses the amount equal to their
    bet. Cards matching either of the first 2 cards are treated as a loss.
    The game is over when there is no money left in the pot. A player 
    status screen is shown at that time show the amounts players have won 
    or lost.  This screen is available at any time by pressing F10.

    To exit the game, press ESC when prompted for your bet.

  
  
  ENDTEXT
  center("Strike any key...")
  inkey(0)
  setmode(25,40)
  setcolor(coldcolor)
  restscreen(0,0,maxrow(),maxcol(),coldscr)
  return nil




