/*
Aug. 13/97. This is a card game I wrote along time ago. I don't think
Clipper is really intended for game programming, but I thought I would see
what I could do. It's not documented and as I recall there are a few bugs.
Anyway, it's public domain. Do as you like with it.
If you fix it up, it would be nice of you to send me a copy.

Regards, TestedOK@aol.com
*/

#command  CLS           => setcolor("bg+/"+cbackgroundcolor); __Clear();banner()
#command  CLRSCR           =>  __Clear()

#include "inkey.ch"

static nhandsize := 7
static adeck
static ncardval := 1
static ccardname := 2
static spade := chr(6)
static heart := chr(3)
static club := chr(5)
static diamond := chr(4)
static cstatuscolor
static cbackgroundcolor := "b"
static cmessagecolor := "g/n"
static cinputcolor := "gr+/n,gr+/n"
static cdealcolor := "bg+/n"
static ndecksize := 52
static ndelay := .05
static nhousemax := 50000
static ncardsleft := 0
static ndeckpos := 1
static ndealrow := 2
static nplayrow := 10
static nchips 
static aplayershand, adealershand
static nmaxchips := 100
static ndealhandval := 0
static nplayhandval := 0
static cdealhandval 
static cplayhandval 
static nrealdealval := 0
static nrealplayval := 0
static ntempval
static nante := 5
static npotval := 0
static ldealerwin := .f.
static lplayerwin := .f.
static ltie := .f.
static canteagain := "Y"
static ldealercalls := .f.
static lplayercalls := .f.
static ldealerfold := .f.
static lplayerfold := .f.
static adealval, aplayval  
static atest

function playpoker(ncards)
  local getlist := {}
  local nrow := 5
  local n
  local nlow,nmiddle,nhigh
  local ncardrow := 8
  local cplayagain := "Y"
  local nkey
  local cpict
  local nbet
  local nplayerdealt, ndealerdealt
  local lshowit := .t.
  if ncards <> nil
    if valtype(ncards) = "N"
      nhandsize := ncards
      else
      nhandsize := val(ncards)
    ENDIF
  endif
  setmode(25,80)
  set decimals to 0
  setkey(-9,{||diddle()})  // so i can change card values
  setkey(-8,{||diddle1()})  // so i can dealer change card values
  setkey(K_F1,{||helppoker()})
  cmessagecolor := "bg+*/"+cbackgroundcolor
  cinputcolor := "gr+/"+cbackgroundcolor+",gr+/" +cbackgroundcolor
  cdealcolor := "bg+/"+cbackgroundcolor
  cstatuscolor := "bg+/"+cbackgroundcolor
  nchips := nmaxchips

  ncardsleft := 0
  setcursor(1)
  set confirm on
  set scoreboard off
  setcolor(cinputcolor)
  cls
  
  setcolor(cinputcolor)
  cls
  // main loop
  do while .t.
    //
    ldealercalls := .f.
    lplayercalls := .f.
    ldealerfold := .f.
    lplayerfold := .f.
    if nchips < 5 // player's lost all chips
      cls
      setpos(maxrow()-1,0)
      center("You lost all you chips!")
      cplayagain := "Y"
      setcolor(cinputcolor)
      @maxrow(),33 say "Play again? " get cplayagain picture "@!";
         valid cplayagain = "Y" .or. cplayagain = "N"
      read
      cls
      if cplayagain = "N"
        clrscr
        return nil
      endif
      ncardsleft := 0
      nchips := nmaxchips
    endif
    if nchips > nhousemax  // house is broke!
      cls
      setpos(maxrow()-1,0)
      center("You broke the house!")
      Tone(261,7  )
      Tone(349,3  )
      Tone(493,20 )
      Tone(440,4  )
      Tone(392,3  )
      Tone(349,3  )
      Tone(329,2  )
      Tone(311,29 )
      cplayagain := "Y"
      setcolor(cinputcolor)
      @maxrow(),0 say "Play again? " get cplayagain picture "@!";
         valid cplayagain = "Y" .or. cplayagain = "N"
      read
      cls
      if cplayagain = "N"
        cls
        return nil
      endif
      ncardsleft := 0
      nchips := nmaxchips
    endif
    //


    npotval := nante * 2
    nchips -= nante
    shuffle()
    nplayerdealt := 0
    ndealerdealt := 0


    aplayershand := {}
    adealershand := {}
    
    setcolor(cdealcolor)
    ndealerdealt := 1
    nplayerdealt := 1
    @maxrow(),0 clear to maxrow(),maxcol()
    @ndealrow+1,0 say "DEALERS HAND "+space(maxcol())
    @nplayrow+1,0 say "YOUR HAND "+ space(maxcol())
    
    aadd(adealershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    dealcard(ndealrow,15,"" )
    ndealerdealt ++
    inkey(ndelay)
    
    aadd(aplayershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    dealcard(nplayrow,7+nplayerdealt*8, adeck[ndeckpos,ccardname] )
    nplayerdealt ++
    inkey(ndelay)
    

    aadd(adealershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    //dealcard(ndealrow,7+ndealerdealt*8, adeck[ndeckpos,ccardname] )
    dealcard(ndealrow,7+ndealerdealt*8, "")
    ndealerdealt ++
    inkey(ndelay)

    
    aadd(aplayershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    dealcard(nplayrow,7+nplayerdealt*8, adeck[ndeckpos,ccardname] )
    nplayerdealt ++
    inkey(ndelay)
    
    
    for n := 1 to nhandsize - 2
      aadd(adealershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
      dealcard(ndealrow,7+ndealerdealt*8, adeck[ndeckpos,ccardname] )
      ndealerdealt ++
      inkey(ndelay)

      aadd(aplayershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
      dealcard(nplayrow,7+nplayerdealt*8, adeck[ndeckpos,ccardname] )
      nplayerdealt ++
      inkey(ndelay)
      
      bet() 
      if lplayerfold .or. ldealerfold
        exit
      endif
    next 
     //diddle()

    if lplayerfold .or. ldealerfold
      lshowit := .f.
      else 
      lshowit := .t.
    endif
    if lshowit
      showchips(nchips)
      clrmessage()
      dealcard(ndealrow,15,adealershand[1,ccardname]  ) // show down card
      dealcard(ndealrow,15+8,adealershand[2,ccardname]  ) // show down card
      aplayval := calchands(aplayershand,1,len(aplayershand))
      /*
      setpos(16,0)
      if len(aplayershand) = nhandsize
       aeval(atest,{|x|qout(x)})
      inkey(0)
      endif
      */
      adealval := calchands(adealershand,1,len(aplayershand))
      
      /*
      setpos(16,0)
      if len(aplayershand) = nhandsize
       aeval(atest,{|x|qout(x)})
      inkey(0)
      endif
      */

      showsummary(adealval,aplayval)
      
    endif
    if lplayerfold
      ldealerwin := .t.
    endif
    if ldealerfold
      lplayerwin := .t.
    endif
    
    //how many chips left 
    if lplayerwin
      nchips := nchips + npotval
    endif
    if ldealerwin
      // all the chips are already in the pot...
    endif
    if ltie
      nchips += npotval / 2 // take half the pot....
    endif
    npotval := 0
    showchips()
    if lplayerfold //easy
      clrmessage()
      message("Player folds!")
      ndeckpos := 1
      for n := 1 to len(aplayershand)
        dealcard(nplayrow,7+n*8, "" )
      next
      inkey(2)
    endif
    if ldealerfold //easy
      clrmessage()
      message("Dealer folds!")
      ndeckpos := 1
      
      for n := 1 to len(adealershand)
        dealcard(ndealrow,7+n*8, "" )
      next
      inkey(2)
      /*
      dealcard(ndealrow,15,adealershand[1,ccardname]  ) // show down card
      dealcard(ndealrow,15+8,adealershand[2,ccardname]  ) // show down card
      inkey(0)
      */
    endif
    clrmessage()
    setcolor(cinputcolor)
    canteagain := "Y"
    if nchips >= nante
      set confirm off
      @maxrow(),30 say "Ante again (Y/N)? " get canteagain picture "@!";
          valid canteagain = "Y" .or. canteagain = "N"
      read
      set confirm on
      else
      inkey(0)
    endif
    if canteagain = "N"
      exit
    endif
  enddo
  // end of main loop
  setmode(25,80)
  clrscr
  return nil

static function random(nseed)
 
 local aray := {77111.35,787919.17,89717.99,77555.11,52212.55,36636.09,;
                61288.87,93117.25,11259.56,83197.45,53513.89,79918.56,;
                63838.18,35283.67,49784.67,66325.33,45629.88,34242.02,;
                77111.35,787919.17,89717.99,77555.11,52212.55,36636.09,;
                61288.87,21517.25,11259.56,83197.45,53513.89,79918.56,;
                63838.18,21483.67,49784.67,66325.33,45629.88,34242.02,;
                98111.35,213919.17,89717.99,77555.11,52212.55,36636.09,;
                61768.87,21217.25,11259.56,83197.45,53513.89,79918.56,;
                14838.18,11283.67,49784.67,66325.33,45629.88,34242.02,;
                12111.35,901919.17,89717.99,77555.11,52212.55,36636.09,;
                34288.87,78117.25,11259.56,83197.45,53513.89,79918.56,;
                56838.18,56283.67,49784.67,66325.33,45629.88,34242.02,;
                78111.35,347919.17,89717.99,77555.11,52212.55,36636.09,;
                90288.87,12117.25,11259.56,83197.45,53513.89,79918.56}
 
 local nretval := 0
 local nlen
 local ctemp := ""
 local npos := 0
 static nstep := 1
 if nseed = nil .or. nseed = 0
   return nseed := int(seconds())
 endif
 while .t.
   nstep ++
   if nstep > len(aray)
     nstep := 1
   endif
   nretval := nseed*aray[nstep]/seconds()*int(seconds())
   ctemp := str(nretval)
   npos := at(".",ctemp)
   nlen := len(alltrim(str(nseed)))
   if npos > 0
     ctemp := substr(ctemp,1,npos-1)+substr(ctemp,npos+1,len(ctemp))
   endif
   ctemp := right(ctemp,nlen)
   nretval := val(ctemp)
   if nretval <= nseed
     exit
   endif
 enddo
return nretval




static FUNCTION center(cstr) //center a string 
  local n
  n:=len(cstr)/2
  @row(),maxcol()/2-n say cstr
  return ""



static function shuffmessage()  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  setpos(maxrow(),0)
  center("Please wait while I shuffle the deck...")
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function message(cmess,ccolor)  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  if ccolor <> nil
     setcolor(ccolor)
  endif
  setpos(maxrow(),0)
  center(cmess)
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function clrmessage()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow(),0 clear to maxrow(),maxcol()
  setcolor(coldcolor)
  return nil


static function newdeck()
  local n,nn,nctr := 1
  static atemp := {}

  if len(atemp) > 0 // build new deck only once
    adeck := aclone(atemp)
    return nil
  endif
  
  adeck := array(ndecksize,2)  // ndecksize is 52 for single deck
  for nn := 3 to 6  // add ace's
      adeck[nctr,1]:=14
      adeck[nctr,2] := "A" + chr(nn)
      nctr++
  next
  for n := 2 to 10 // regular cards
    for nn := 3 to 6  // add the suits
      adeck[nctr,1]:=n
      adeck[nctr,2] := alltrim(str(n)) + chr(nn)
      nctr++
    next
  next
  for nn := 3 to 6  // add jack's
    adeck[nctr,1]:=11
    adeck[nctr,2] := "J" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add queen's
    adeck[nctr,1]:=12
    adeck[nctr,2] := "Q" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add king's
    adeck[nctr,1]:=13
    adeck[nctr,2] := "K" + chr(nn)
    nctr++
  next
  atemp := aclone(adeck)
return nil


static function shuffle()
  local n,ncard
  local atemp := array(52,2)
  
  
  setcolor(cinputcolor)
  cls
  shuffmessage()
  newdeck()
  ncardsleft := ndecksize
  ndeckpos := 1
  
  for n := 1 to nhandsize * 2 + 2
    
    do while .t.
      ncard := random(52)
      if ncard = 0
        loop
      endif
      if adeck[ncard,1] <> 99
        atemp[n,1] := adeck[ncard,1]
        atemp[n,2] := adeck[ncard,2]
        adeck[ncard,1] := 99
        exit
      endif
    enddo
  next
  adeck := aclone(atemp)
  clrmessage()
return nil



static function  potvaluemess()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 clear to maxrow()-2,maxcol()
  setpos(maxrow()-2,0)
  center("There is "+alltrim(str(npotval))+" in the pot.")
  setcolor(coldcolor)
return nil

static function anykeymessage()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 clear to maxrow()-2,maxcol()
  setpos(maxrow()-2,0)
  center("Strike any key...")
  setcolor(coldcolor)
return nil

static function banner()
 local coldcolor := setcolor("r/w")
 @0,0 clear to 0,maxcol()
 center("P O K E R")
 @0,0 say "F1=help"
 setcolor(coldcolor) 
return nil

static function pright(cstr) // right justify a string
  local nlen := len(cstr)
  @row(),maxcol()-nlen+1 say cstr
  return nil


static function dealcard(nrow,ncol,ccardname )
  local n, noldrow := nrow
  local coldcolor := setcolor("b/w")
  
  setpos(nrow,ncol)
  
  @nrow,ncol to nrow + 5 , ncol + 6
  if empty(ccardname) // the dealer's down card
    for n:=1 to 4
      @nrow+1,ncol+1 say replicate(chr(176),5)
      nrow++
    next
    else
    for n:=1 to 4
      @nrow+1,ncol+1 say replicate(" ",5)
      nrow++
    next
  endif
  nrow := noldrow
  if right(alltrim(ccardname),1) = chr(6) .or.; // it's a club or spade
        right(alltrim(ccardname),1) = chr(5)
    setcolor("n/w")
    else
    setcolor("r/w")
  endif
  @nrow+1,ncol+1 say alltrim(ccardname)
  @nrow+4,ncol+6-len(alltrim(ccardname)) say alltrim(ccardname)
  setcolor(coldcolor)
  ncardsleft --
  ndeckpos ++
  return nil



function helppoker()
  local coldscr := savescreen(0,0,maxrow(),maxcol())
  local coldcolor := setcolor("gr+/r")
  setmode(25,80)
  clrscr
  banner()
  setpos(2,0)
  TEXT
    In the game of POKER, a standard deck of cards is used.

    To exit the game, press ESC when prompted for your bet.

  
  
  ENDTEXT
  center("Strike any key...")
  inkey(0)
  setcolor(coldcolor)
  restscreen(0,0,maxrow(),maxcol(),coldscr)
  return nil

static function showchips()
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-3,0 clear to maxrow()-2, maxcol()
  @maxrow()-2,0 say "You have "+alltrim(str(nchips))+" chips."
  if npotval > 0
    @maxrow()-3,0 say "There is "+alltrim(str(npotval))+ " chips in the pot."
  endif
  setcolor(coldcolor)
return nil


static function showsummary(adealval,aplayval) //easy
    ldealerwin := .f.
    lplayerwin := .f.
    ltie := .f.
    setpos(18,0)
    @18,0 clear to maxrow(),maxcol()
    if adealval[1] > aplayval[1]  // dealer wins
      @row(),30 say "Dealer WINS with "+adealval[2]
      @row()+1,30 say "Player has "+aplayval[2]
      ldealerwin := .t.
    endif
    if adealval[1] < aplayval[1]  // player wins
      @row(),30 say "Dealer has  "+adealval[2]
      @row()+1,30 say "Player WINS with "+aplayval[2]
      lplayerwins := .t. 
    endif
    if adealval[1] = aplayval[1]  //tie
      @row(),30 say "Dealer has  "+adealval[2]
      @row()+1,30 say "Player has "+aplayval[2]
      @row()+1,30 say "Dealer and player tie!"
      ltie := .t.
    endif
    /*
    setpos(16,0)
    for n := 1 to len(aplayershand)
      ? aplayershand[n,1], adealershand[n,1]
    next
    ?
    ? aplayval[1],  adealval[1]
    
    inkey(0)
    */

    return nil


function diddle()
  local coldscr := savescreen(0,0,maxrow(),maxcol())
  local getlist := {},n,nrow := 1
  cls
  ? "players hand"
  ?
  for n := 1 to len(aplayershand)
    @nrow,0 get aplayershand[n,1]
    @nrow,15 get adeck[n,2]
    nrow ++
  next
  read
  restscreen(0,0,maxrow(),maxcol(),coldscr)
  return nil


function diddle1()
  local coldscr := savescreen(0,0,maxrow(),maxcol())
  local getlist := {},n,nrow := 1
  cls
  ? "dealers hand"
  ?
  for n := 1 to len(adealershand)
    @nrow,0 get adealershand[n,1]
    @nrow,15 get adeck[n,2]
    nrow ++
  next
  read
  restscreen(0,0,maxrow(),maxcol(),coldscr)
  return nil

static function isflush(a)
   local a_ := {}, n, nspades := 0, nhearts := 0, nclubs := 0, ndiamonds := 0
   aeval(a,{|x|aadd(a_,right(alltrim(x[2]),1))})
   for n := 1 to len(a_)
     do case
       case a_[n] = spade
         nspades ++
       case a_[n] = heart
         nhearts ++
       case a_[n] = club
         nclubs ++
       case a_[n] = diamond
         ndiamonds ++
     endcase
   next
   
   /*
   setpos(16,0)
   ? "spades",nspades
   ? "hearts" , nhearts
   ? "clubs" , nclubs
   ? "diamonds", ndiamonds
   inkey(0)
   */
   if nspades = 5 .or. nspades = len(a_)
     return .t.
   endif
   if nhearts = 5 .or. nhearts = len(a_)
     return .t.
   endif
   if nclubs = 5 .or. nclubs = len(a_)
     return .t.
   endif
   if ndiamonds = 5 .or. ndiamonds = len(a_)
     return .t.
   endif

return .f.



static function cardword(ncard)
 local ccard := ""
 do case
   case ncard = 2
     ccard := "Deuce"
   case ncard = 3
     ccard := "Three"
   case ncard = 4
     ccard := "Four"
   case ncard = 5
     ccard := "Five"
   case ncard = 6
     ccard := "Six"
   case ncard = 7
     ccard := "Seven"
   case ncard = 8
     ccard := "Eight"
   case ncard = 9
     ccard :=  "Nine"
   case ncard = 10
     ccard := "Ten"
   case ncard = 11
     ccard := "Jack"
   case ncard = 12
     ccard := "Queen"
   case ncard = 13
     ccard := "King"
   case ncard = 14
     ccard := "Ace"
 endcase
return ccard


static function calchands(aray,nstart,nstop) // return hand value
     local a_ := {}
     local n,nn:=1
     local lstraight := .f.
     local lflush := .f.
     local nhandval := 0
     local aretval := array(1,2)  
     local atemp,anumbers
     local ltight := .f.
     local lpair := .f.

     local sflush := 900
     local fourofakind := 800
     local tight := 700
     local flush := 600
     local straight := 500
     local threeofakind := 400
     local twopair := 300
     local onepair := 200
     local bust := 100

     ntempval := 0
     for n := nstart to nstop
       aadd(a_,aray[n])
     next
     
     a_ := ASORT(a_,,, { |x, y| x[1] < y[1] })
    
     lstraight := isstraight(a_)
     lflush := isflush(a_)


    // STRAIGHT FLUSH ?
      if lstraight .and. lflush .and. len(a_) > 3
         return aretval := {sflush+ntempval,"a Straight Flush"}
      endif

   // FOUR OF A KIND ?
       if len(a_) >= 4
         anumbers := array(14)
         afill(anumbers,0)
         for n := 1 to len(a_)
           anumbers[a_[n,1]]++
         next
         for n:=len(anumbers) to 1 step-1
            if anumbers[n] = 4 // got 4 of a kind!
              ntempval += n*4
              return aretval := {fourofakind+ntempval,"4 of a kind"}
            endif
         next
       endif

   // TIGHT?
       atemp := aclone(a_)
       if len(atemp) >= 5
         anumbers := array(14)
         afill(anumbers,0)
         for n := 1 to len(atemp)
           anumbers[atemp[n,1]]++
         next
         for n:=len(anumbers) to 1 step-1
            if anumbers[n] = 3 // got 3 of a kind!
              ntempval += n*3
              ltight := .t.
            endif
         next
       endif
       
       if ltight
         if len(a_) >= 2
           anumbers := array(14)
           afill(anumbers,0)
           for n := 1 to len(a_)
             anumbers[a_[n,1]]++
           next
           for n:=len(anumbers) to 1 step-1
              if anumbers[n] = 2 // got a pair!
                ntempval += n*2
                return aretval := {tight+ntempval,"a Full House"}
              endif
           next
         endif
       endif

   // FLUSH?
      if lflush .and. len(a_) > 3
         return aretval := {flush+ntempval,"a Flush"}
      endif

   // STRAIGHT? .and. len(a_) > 3
      if lstraight 
         return aretval := {straight+ntempval,"a Straight"}
      endif

   // THREE OF A KIND
       if len(a_) >= 3
         anumbers := array(14)
         afill(anumbers,0)
         for n := 1 to len(a_)
           anumbers[a_[n,1]]++
         next
         for n:=len(anumbers) to 1 step-1
            if anumbers[n] = 3 // got 3 of a kind!
              ntempval += n*3
              return aretval := {threeofakind+ntempval,"Three "+;
                cardword(n)+"'s"}
            endif
         next
       endif

   // TWO PIAR
       nn := 0
       if len(a_) >= 2
         anumbers := array(14)
         afill(anumbers,0)
         for n := 1 to len(a_)
           anumbers[a_[n,1]]++
         next
         for n:=len(anumbers) to 1 step-1
            if anumbers[n] = 2 // got a pair!
              nn ++
              ntempval += n*2
              if nn = 2  
                return aretval := {twopair+ntempval,"2 pair"}
              endif
            endif
         next
       endif
   
   
   // ONE PAIR
       if len(a_) >= 2
         anumbers := array(14)
         afill(anumbers,0)
         for n := 1 to len(a_)
           anumbers[a_[n,1]]++
         next
         for n:=len(anumbers) to 1 step-1
            if anumbers[n] = 2 // got a pair!
              ntempval += n*2
              return aretval := {onepair+ntempval,"Pair of "+;
                cardword(n)+"'s"}
            endif
         next
       endif

   // BUST
      ntempval := 0
      for n := 1 to len(a_)
        if n > 5
          exit
        endif
        ntempval += a_[n,1]
      next
      return aretval := {0+ntempval,"a bust hand"}

static function bet()
  showchips()
  aplayval := calchands(aplayershand,3,len(aplayershand))
  adealval := calchands(adealershand,3,len(aplayershand))
  if aplayval[1] > adealval[1]
    playerbets()
    else 
    dealerbets(aplayval[1])
  endif
  return nil

static function playerbets()
    local getlist := {}
    local nbet := 0
    aplayval := calchands(aplayershand,3,len(aplayershand))
    adealval := calchands(adealershand,1,len(adealershand))
    clrmessage()
    setcolor(cinputcolor)
    @maxrow(),25 say "How many chips do you want to bet?" get nbet; 
        picture "99999" valid nbet <= nchips
    read
    /*
    setpos(15,15)
    @15,0 clear to 15,25
    ? aplayval[1], adealval[1]
    */
    if nbet > 0
      if adealval[1] + 100 < aplayval[1]
        ldealerfold := .t.
        return nil
      endif
    endif
    npotval += nbet*2
    nchips -= nbet
  return nil

static function dealerbets(nplayval)
  local ccall := "C"
  local getlist := {}
  local ndlrbet := 5
  set confirm off
  clrmessage()
  adealval := calchands(adealershand,1,len(adealershand))
  if adealval[1] > nplayval .and. adealval[1] > 200 //easy
    setcolor(cinputcolor)
    @maxrow(),19 say "Dealer bets "+alltrim(str(ndlrbet))+ " chips."+;
          " (C)all (F)old (R)aise?" get ccall picture "@!" ;
          valid ccall = "C" .or. ccall = "F" .or. ccall = "R"
    read
    if ccall = "C"
      npotval += ndlrbet*2
      nchips -= ndlrbet
    endif
    if ccall = "R"
      npotval += ndlrbet*2
      nchips -= ndlrbet
      showchips()
      playerbets()
    endif
    if ccall = "F"
      lplayerfold := .t.
    endif  
    else
    setpos(maxrow(),0)
    center("Dealer checks.")
    inkey(2)
    playerbets()
  endif
  return nil



function oldisstraight(b)
  local a_:={},n,ntemp,i,aa,aa_
  local a := aclone(b)
  aeval(a,{|x| aadd(a_,x[1]) } )
  a_ := ASORT(a_,,, { |x,y| x > y })
  a := ASORT(a,,, { |x,y| x[1] > y[1] })
  
  for i := 1 to len(a_)
    ntempval := 0
    ntemp := a_[i]
    for n := i to len(a_)
      if a_[n] = ntemp-1
        ntemp := a_[n]
        ntempval += a_[n-1]
        else
        exit
      endif
      if n > 4
        ntempval += a_[n]
        return .t. // only count 5 cards
      endif
    next
  next
  
  //turn ace's into 1, see if we can get a small straight..
  a_:={}
  aa := aclone(a)
  //return .f.
  aeval(aa,{|x|if(x[1]=14,x[1]:=1,""), aadd(a_,x[1]) } )
  a_ := ASORT(a_,,, { |x,y| x > y })
  aa := ASORT(aa,,, { |x,y| x[1] > y[1] })
  

  for i := 1 to len(a_)
    ntempval := 0
    ntemp := a_[i]
    for n := 2 to len(a_)
      if a_[n] = ntemp-1
        ntemp := a_[n]
        ntempval += a_[n-1]
        else
        exit
      endif
      if n > 4
        ntempval += a_[n]
        return .t. // only count 5 cards
      endif
    next
  next
  
  ntempval := 0
  return .f.






function isstraight(a_)
  local n 
  local anumbers := array(14)
  local nhits := 0
  local a := aclone(a_)

  afill(anumbers,.f.)
  for n := 1 to len(a)
    anumbers[a[n,1]] := .t.
  next
  nhits := 0
  for n := len(anumbers) to 1 step -1
    if anumbers[n] 
      nhits++
      ntempval += n
      if nhits = 5
        return .t.
      endif
      else
      nhits := 0
      ntempval := 0
    endif
  next
  
  // turn ace's into 1 and look again
  aeval(a,{|x|if(x[1]=14,x[1]:=1,"")})
  afill(anumbers,.f.)
  for n := 1 to len(a)
    anumbers[a[n,1]] := .t.
  next
  nhits := 0
  for n := len(anumbers) to 1 step -1
    if anumbers[n] 
      nhits++
      ntempval += n
      if nhits = 5
        return .t.
      endif
      else
      nhits := 0
      ntempval := 0
    endif
  next

  ntempval := 0
  return .f.


