/*
Aug. 13/97. This is a card game I wrote along time ago. I don't think
Clipper is really intended for game programming, but I thought I would see
what I could do. It's not documented and as I recall there are a few bugs.
Anyway, it's public domain. Do as you like with it.
If you fix it up, it would be nice of you to send me a copy.

Regards, TestedOK@aol.com
*/

#command  CLS  => setcolor("bg+/"+cbackgroundcolor); __Clear();banner()
#command  CLRSCR   =>  __Clear()
# include "inkey.ch"

static adeck
static ncardval := 1
static ccardname := 2
static spade := chr(6)
static heart := chr(3)
static club := chr(5)
static diamond := chr(4)
static cbackgroundcolor := "b"
static cmessagecolor 
static cinputcolor 
static cdealcolor 
static cstatuscolor
static ndecksize := 52
static ndelay := 2
static nhousemax := 20000
static lmono := .f.
static lonecard := .f.

function play21(cdelay,cmono)
  local nmaxchips := 20
  local nchips 
  local nbet := 0
  local getlist := {}
  local ncardsleft := 0
  local ndealerdealt := 0
  local nplayerdealt := 0
  local ndeckpos := 1
  local caction := " "
  local aplayershand
  local adealershand
  local ldoubledown := .f.
  local lplayerbust := .f., ldealerbust := .f.
  local nplayerhandval
  local ndealerhandval
  local cplayagain := "Y"
  local ndealrow := 2
  local nplayrow := 10
  
  set confirm off
  setmode(25,80)
  setkey(K_F1,{||help21()})
  cmessagecolor := "bg+*/"+cbackgroundcolor
  cinputcolor := "gr+/"+cbackgroundcolor+",gr+/" +cbackgroundcolor
  cdealcolor := "bg+/"+cbackgroundcolor
  cstatuscolor := "bg+/"+cbackgroundcolor
  
  if cdelay <> nil
    ndelay := val(cdelay)
  endif
  if cmono <> nil
    cbackgroundcolor := "n"
    cmessagecolor := "w+*/"+cbackgroundcolor
    cinputcolor := "w+/"+cbackgroundcolor+",w+/" +cbackgroundcolor
    cdealcolor := "w+/"+cbackgroundcolor
    cstatuscolor := "w+/"+cbackgroundcolor
    lmono := .t.
  endif
  cls
  set scoreboard off

  nchips := nmaxchips
  while .t.
    if nchips < 1 // player's lost all chips
      cls
      setpos(maxrow()-1,0)
      center("You lost all you chips!")
      * taunt "NANNY NANNY BOO BOO".
      /*
      Tone(294,3)
      Tone(294,1)
      Tone(247,5)
      Tone(330,2)
      Tone(294,5)
      Tone(247,9)
      */

      cplayagain := "Y"
      setcolor(cinputcolor)
      @maxrow(),33 say "Play again? " get cplayagain picture "@!";
         valid cplayagain = "Y" .or. cplayagain = "N"
      read
      cls
      if cplayagain = "N"
        clrscr
        return nil
      endif
      ncardsleft := 0
      nchips := nmaxchips
    endif
    if nchips > nhousemax  // house is broke!
      cls
      setpos(maxrow()-1,0)
      center("You broke the house!")
      Tone(261,7  )
      Tone(349,3  )
      Tone(493,20 )
      Tone(440,4  )
      Tone(392,3  )
      Tone(349,3  )
      Tone(329,2  )
      Tone(311,29 )
      cplayagain := "Y"
      setcolor(cinputcolor)
      @maxrow(),0 say "Play again? " get cplayagain picture "@!";
         valid cplayagain = "Y" .or. cplayagain = "N"
      read
      cls
      if cplayagain = "N"
        cls
        return nil
      endif
      ncardsleft := 0
      nchips := nmaxchips
    endif
    aplayershand := {}
    adealershand := {}
    if ncardsleft < 10
      cls  // easy
      shuffmessage()
      newdeck()
      shuffle()
      ncardsleft := ndecksize
      ndeckpos := 1
      clrmessage()
    endif
    cls
    showchips(nchips)
    setcolor(cinputcolor)
    nbet := 1
    @maxrow(),0 say "How many chips do you want to bet?" get nbet; 
        picture "99999" valid okbet(nbet,nchips)
    read
    if lastkey() = 27
      exit
    endif
    clrmessage()
    // give dealer 2 cards
    setcolor(cdealcolor)
    ndealerdealt := 1
    nplayerdealt := 1
    @maxrow(),0 clear to maxrow(),maxcol()
    @ndealrow+1,0 say "DEALERS HAND "+space(maxcol())
    dealcard(ndealrow,15,"" )
    aadd(adealershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    ndeckpos ++
    ndealerdealt ++
    dealcard(ndealrow,7+ndealerdealt*8, adeck[ndeckpos,ccardname] )
    aadd(adealershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    ndeckpos ++
    ndealerdealt ++

    // give player 2 cards
    @nplayrow+1,0 say "YOUR HAND "+ space(maxcol())
    dealcard(nplayrow,7+nplayerdealt*8, adeck[ndeckpos,ccardname] )
    aadd(aplayershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    ndeckpos ++
    nplayerdealt ++
    dealcard(nplayrow,7+nplayerdealt*8, adeck[ndeckpos,ccardname] )
    aadd(aplayershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
    ndeckpos ++
    nplayerdealt ++
    ldoubledown := .t.
    lplayerbust := .f. 
    ldealerbust := .f.
    lonecard := .f. // only one card if player doubles down
    do while .t.  // the players hand
      nplayerhandval := handvalue(aplayershand)
      showbet(nbet,nplayerhandval)
      clrmessage()
      caction := " "
      setcolor(cinputcolor)
      if candouble(aplayershand,nbet,nchips) .and. ldoubledown
        @maxrow(),0 say "(H)it (S)tand (D)ouble down " get caction; 
         picture "! " valid caction = "H" .or. caction = "S" .or. caction = "D"
         ldoubledown := .f.
         read
         else
        @maxrow(),0 say "(H)it (S)tand " get caction; 
         picture "! " valid caction = "H" .or. caction = "S" 
         read
      endif  
      if caction = "D" 
        nbet := nbet + nbet
        lonecard := .t.
        caction := "H"
      endif
      if caction = "H" // hit again
         setcolor(cdealcolor)
         dealcard(nplayrow,7+nplayerdealt*8, adeck[ndeckpos,ccardname] )
         aadd(aplayershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
         ndeckpos ++
         nplayerdealt ++
         // has player gone over 21? if so exit the loop and take their chips..
         nplayerhandval := handvalue(aplayershand)
         if nplayerhandval > 21 // bust!
           nchips := nchips - nbet
           @maxrow()-4,0 clear to maxrow(),maxcol()
           message("YOU BUST with "+alltrim(str(nplayerhandval))+;
             "!! You loose " + alltrim(str(nbet)) + " chips.")
           // easy
           dealcard(ndealrow,15, adealershand[1,2] ) // show the down card //
           bustsong()
           lplayerbust := .t.
           inkey(ndelay)
           exit
         endif
         if lonecard // player has doubled down
           nplayerhandval := handvalue(aplayershand)
           showbet(nbet,nplayerhandval)
           inkey(1)
           exit
         endif
      endif
      if caction = "S"
         nplayerhandval := handvalue(aplayershand)
         exit
      endif  
    enddo // the players hand
    // easy
    if lplayerbust  // no need to give the dealer cards
      ncardsleft := ndecksize - ndeckpos
      loop
    endif
    
    // the dealers hand
    // dealer will stand on 17 draw on 16 ....
      @maxrow(),0 clear to maxrow(),maxcol()
    // show down card ....
    setcolor(cdealcolor)
    dealcard(ndealrow,15, adealershand[1,2] )
    do while .t.
      // has dealer gone over 21? if so exit the loop and pay their bet..
      ndealerhandval := handvalue(adealershand)
      if ndealerhandval > 16 .and. ndealerhandval < 22 // can't draw
        exit
      endif
      if ndealerhandval < 21 ///
        dealcard(ndealrow,7+ndealerdealt*8, adeck[ndeckpos,ccardname] )
        aadd(adealershand,{adeck[ndeckpos,ncardval],adeck[ndeckpos,ccardname]})
        ndeckpos ++
        ndealerdealt ++
      endif
      if ndealerhandval > 21 // bust!
        @maxrow()-4,0 clear to maxrow(),maxcol()
        if nplayerhandval = 21 .and. len(aplayershand) = 2
          message("You have BLACKJACK! Dealer pays double. You won "+alltrim(str(nbet*2)) + " chips.")
          nchips += nbet*2
          else
          message("DEALER BUST with "+alltrim(str(ndealerhandval))+"!! You win " +; 
                       alltrim(str(nbet)) + " chips.")
          nchips += nbet
          bustsong()
        endif
        ldealerbust := .t.
        inkey(ndelay)
        exit
      endif
   enddo
   if ldealerbust .or. lplayerbust
     ncardsleft := ndecksize - ndeckpos
     loop
   endif
   do case 
    
    // does player have blackjack?? if so, pay double...
    case nplayerhandval = 21 .and. len(aplayershand) = 2
      if ndealerhandval = 21 .and. len(adealershand) = 2 // so does the dealer
        showchips(nchips)
        message("Dealer and player tie!")
        else
        nchips += nbet*2
        showchips(nchips)
        message("You have BLACKJACK! Dealer pays double. You won "+alltrim(str(nbet*2)) + " chips.")
      endif
   
    // does dealer have blackjack?? 
    case ndealerhandval = 21 .and. len(adealershand) = 2
      if nplayerhandval = 21 .and. len(aplayershand) = 2 // so does the player
        showchips(nchips)
        message("Dealer and player tie!")
        else
        nchips -= nbet
        showchips(nchips)
        message("Dealer has BLACKJACK! You loose "+alltrim(str(nbet)) + " chips.")
     endif
   
     case ndealerhandval > nplayerhandval  // dealer wins..
      nchips -= nbet
      showchips(nchips)
      message("Dealer wins. You lost "+alltrim(str(nbet)) + " chips.")
         
    case ndealerhandval < nplayerhandval  // player wins..
      nchips += nbet
      showchips(nchips)
      message("You win! You won "+alltrim(str(nbet)) + " chips.")
    
    case ndealerhandval = nplayerhandval  // tie..
      showchips(nchips)
      message("Dealer and player tie!")
  
  endcase 

    setpos(nplayrow+9,0)
    @row()+1,0 clear to maxrow()-1,maxcol()
    ? "Dealers hand "+ alltrim(str(ndealerhandval))
    ? "Players hand " + alltrim(str(nplayerhandval))
    inkey(ndelay)
    ncardsleft := ndecksize - ndeckpos
  enddo
  clrscr 

return nil




static function random(nseed)
 local aray := {77111.35,787919.17,89717.99,77555.11,52212.55,36636.09,;
                63838.18,35283.67,49784.67,66325.33,;
                61288.87,93117.25,11259.56,83197.45,53513.89,79918.56}
 local nretval := 0
 local nlen
 local ctemp := ""
 local npos := 0
 static nstep := 1
 if nseed = nil .or. nseed = 0
   return nseed := int(seconds())
 endif
 while .t.
   nstep ++
   if nstep > len(aray)
     nstep := 1
   endif
   nretval := nseed*aray[nstep]/seconds()*int(seconds())
   ctemp := str(nretval)
   npos := at(".",ctemp)
   nlen := len(alltrim(str(nseed)))
   if npos > 0
     ctemp := substr(ctemp,1,npos-1)+substr(ctemp,npos+1,len(ctemp))
   endif
   ctemp := right(ctemp,nlen)
   nretval := val(ctemp)
   if nretval <= nseed
     exit
   endif
 enddo
return nretval





static FUNCTION center(cstr) //center a string 
  local n
  n:=len(cstr)/2
  @row(),maxcol()/2-n say cstr
  return nil


  

static function shuffmessage()  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  setpos(maxrow(),0)
  center("Please wait while I shuffle the deck...")
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function message(cmess)  
  local coldcolor := setcolor(cmessagecolor)
  local noldcol := col()
  local noldrow := row()
  setpos(maxrow(),0)
  center(cmess)
  setcolor(coldcolor)
  setpos(noldrow,noldcol)
  return nil

static function clrmessage()
  @maxrow(),0 clear to maxrow(),maxcol()
  return nil


static function newdeck()
  local n,nn,nctr := 1, NNN
  static atemp := {}

  if len(atemp) > 0 // build new deck only once
    adeck := aclone(atemp)
    return nil
  endif
  
  adeck := array(ndecksize,2)  // ndecksize is 52 for single deck
  
  for nnn := 1 to ndecksize/52
  for nn := 3 to 6  // add ace's
      adeck[nctr,1]:=11
      adeck[nctr,2] := "A" + chr(nn)
      nctr++
  next
  for n := 2 to 10 // regular cards
    for nn := 3 to 6  // add the suits
      adeck[nctr,1]:=n
      adeck[nctr,2] := alltrim(str(n)) + chr(nn)
      nctr++
    next
  next
  for nn := 3 to 6  // add jack's
    adeck[nctr,1]:=10
    adeck[nctr,2] := "J" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add queen's
    adeck[nctr,1]:=10
    adeck[nctr,2] := "Q" + chr(nn)
    nctr++
  next
  for nn := 3 to 6  // add king's
    adeck[nctr,1]:=10
    adeck[nctr,2] := "K" + chr(nn)
    nctr++
  next
  //
  next // deck nnn
  atemp := aclone(adeck)
return nil


static function shuffle()
  local n,ncard
  local atemp := array(ndecksize,2)
  
  for n := 1 to ndecksize
    do while .t.
      ncard := random(ndecksize)
      if ncard = 0
        loop
      endif
      if adeck[ncard,1] <> 99
        atemp[n,1] := adeck[ncard,1]
        atemp[n,2] := adeck[ncard,2]
        adeck[ncard,1] := 99
        exit
      endif
    enddo
  next
  adeck := aclone(atemp)
return nil

static function showchips(nchips)
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-2,0 say "You have "+alltrim(str(nchips))+" chips."
  setcolor(coldcolor)
return nil

static function showbet(nbet,handval)
  local coldcolor := setcolor(cstatuscolor)
  @maxrow()-3,0 say "You have " + alltrim(str(handval)) + " showing."
  @maxrow()-1,0 say "You have bet "+alltrim(str(nbet))+" chips."
  setcolor(coldcolor)

return nil

static function okbet(nbet,nchips)
  if nbet > nchips .or. nbet = 0
    return .f.
  endif

return .t.

// can player double down??
static function candouble(aplayershand,nbet,nchips)
  local a_ := aclone(aplayershand)
  local ntemp := nbet * 2
  
  if ntemp > nchips
    return .f.
  endif
  if len(a_) > 2
    return .f.
  endif
  /*
  if substr(a_[1,2],1,len(alltrim(a_[1,2]))-1) ==;
                substr(a_[2,2],1,len(alltrim(a_[2,2]))-1)
      return .t.
  endif
  */
  return .t.


static function handvalue(ahand) // find best value for hand
  local nval := 0
  local nctr := 1
  local npos := 0
  local atemp := {}
  aeval(ahand,{|x| nval += x[1] , aadd(atemp,x[1]) })
  if nval > 21 // see if there are ace's we can count as 1...
    do while .t.
      npos := ascan(atemp,11,npos+1)
      if npos = 0
        exit
      endif
      nval := nval - 10
      if nval <= 21
        return nval
      endif
    enddo
  endif
  return nval


static function dealcard(nrow,ncol,ccardname )
  local n, noldrow := nrow
  local coldcolor := if(!lmono,setcolor("b/w"),setcolor("n/w"))
  setpos(nrow,ncol)
  
  @nrow,ncol to nrow + 5 , ncol + 6
  if empty(ccardname) // the dealer's down card
    for n:=1 to 4
      @nrow+1,ncol+1 say replicate(chr(176),5)
      nrow++
    next
    else
    for n:=1 to 4
      @nrow+1,ncol+1 say replicate(" ",5)
      nrow++
    next
  endif
  nrow := noldrow
  if right(alltrim(ccardname),1) = chr(6) .or.; // it's a club or spade
        right(alltrim(ccardname),1) = chr(5)
    setcolor("n/w")
    else
    if !lmono
      setcolor("r/w")
    endif
  endif
  @nrow+1,ncol+1 say alltrim(ccardname)
  @nrow+4,ncol+6-len(alltrim(ccardname)) say alltrim(ccardname)
  setcolor(coldcolor)
  return nil


FUNCTION HELP21()                                                                               
  local coldcolor := if(!lmono,setcolor("r/w"),setcolor("n/w"))
  local coldscr := savescreen(0,0,maxrow(),maxcol())
  clrscr
  TEXT
                              B L A C K J A C K                  
                                                                               
                   In the game of Blackjack, a standard deck                   
                   of cards is used. After you bet, the 
                   computer (dealer) will deal  two  cards 
                   face up to you  and two cards to itself, 
                   one face up and the other face down.                                            
                   The object is to come as close to twenty-                   
                   one  (21)  as possible without  `busting'                   
                   by going over twenty-one. Aces can count                    
                   as one or eleven,face cards are ten, and                    
                   all other cards are face value.  You may                    
                   take a HIT (another card to better  your                    
                   hand), STAND  (play the cards you have),                    
                   or DOUBLE DOWN (double your bet).  If you
                   DOUBLE DOWN, you will be dealt one more 
                   card.  If dealer and player tie, player 
                   keeps bet.
                   To exit the game, press ESC when asked
                   to place bet.
                                                                              
                                STRIKE ANY KEY...
 ENDTEXT
 inkey(0)
 setcolor(coldcolor) 
 restscreen(0,0,maxrow(),maxcol(),coldscr)
 return nil

static function banner()
 local coldcolor := if(!lmono,setcolor("r/w"),setcolor("n/w"))
 @0,0 clear to 0,maxcol()
 center("B L A C K J A C K")
 @0,0 say "F1=help"
 setcolor(coldcolor) 
return nil

static function bustsong()
   TONE(300, 1)
   TONE(100, 1)
   TONE(300, 1)
   TONE(100, 1)
return nil
